/***********************************************************************************************************************
* File Name    : eeprom.c
* Version      : CodeGenerator for RL78/G13 V2.05.03.01 [12 Nov 2018]
* Device(s)    : R5F100LL
* Tool-Chain   : CCRL
* Description  : This file implements main function.
* Creation Date: 2019/11/16
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_intc.h"
#include "r_cg_serial.h"
#include "r_cg_adc.h"
#include "r_cg_timer.h"
#include "r_cg_wdt.h"
#include "r_cg_it.h"
/* Start user code for include. Do not edit comment generated here */
#include <stdbool.h>
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
#define BYTE unsigned char
#define DWORD unsigned long int
#define WORD unsigned int
uint8_t tx_bufA[4];
uint8_t rx_bufA[4];
uint8_t tx_numA;
WORD readDATA[10];
DWORD readDATA2[2]; 
extern uint16_t __near DESTINATION[10U];
extern volatile uint8_t  g_csi11_comflag;           /* csi11 transfer flag  */
void S_WAITTSV(void);                               /* wait for 16clocks    */
uint8_t S_CHKEND(void);                             /* check warite status  */
void S_COMUNICATION(void);                          /* CSI00 communication  */
void S_MICRO_WRITE(uint8_t, uint16_t);              /* write data to EEPROM */
uint16_t S_MICRO_READ(uint8_t);                     /* read a word data     */
void S_MICRO_ERAL(void);                            /* erase in whole chip  */
void S_MICRO_EWDS(void);                            /* set write disable    */
void S_MICRO_EWEN(void);                            /* set write enable     */
_Bool  init_eprom (void ); 				/* ; EEPROM  */
_Bool  read_eeprom (uint8_t , uint8_t , WORD* ); 		/* ; EEPROM ǂݍ */
_Bool  read_eeprom2 (uint8_t , uint8_t , DWORD* ); 		/* ; EEPROM ǂݍ */
_Bool  write_eeprom (uint8_t, uint16_t); 		/* ; EEPROM  */

/***********************************************************************************************************************
* Function Name: S_MICRO_EWEN
* Description  : This function set EEPROM to write enable
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void S_MICRO_EWEN(void)
{
    tx_bufA[0] = 0b00000001;                /* set EWEN instruction for EEPROM */
    tx_bufA[1] = 0b00110000;
    tx_numA = 2U;                           /* send data number             */

    P0_bit.no5 = 1U;                        /* set CS signal ON             */
    S_COMUNICATION();                       /* send instruction             */
    P0_bit.no5 = 0U;                        /* set CS signal OFF */
}

/***********************************************************************************************************************
* Function Name: S_MICRO_EWDS
* Description  : This function set EEPROM to write disable
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void S_MICRO_EWDS(void)
{
    tx_bufA[0] = 0b00000001;                /* set start bit for EEPROM     */
    tx_bufA[1] = 0b00000000;
    tx_numA = 2U;                           /* send data number             */

    P0_bit.no5 = 1U;                        /* set CS signal ON             */
    S_COMUNICATION();                       /* send instruction             */
    P0_bit.no5 = 0U;                        /* set CS signal OFF */
}

/***********************************************************************************************************************
* Function Name: S_MICRO_ERAL
* Description  : This function erase all data of EEPROM
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void S_MICRO_ERAL(void)
{
    tx_bufA[0] = 0b00000001;                /* set start bit for EEPROM     */
    tx_bufA[1] = 0b00100000;                /* set instruction              */
    tx_numA = 2U;                           /* send data number             */

    P0_bit.no5 = 1U;                        /* set CS signal ON             */
    S_COMUNICATION();                       /* send instruction             */
    P0_bit.no5 = 0U;                        /* set CS signal OFF */
}

/***********************************************************************************************************************
* Function Name: S_MICRO_READ
* Description  : This function reads one address from EEPROM
* Arguments    : address
* Return Value : read data
***********************************************************************************************************************/
uint16_t S_MICRO_READ(uint8_t address8)
{
    uint16_t    readdata;
    tx_bufA[0U] = 0b00000001;               /* set start bit for EEPROM     */
//    tx_bufA[1U] = (uint8_t)((address8 << 1U) & 0b01111110); /* set instruction and address  */
    tx_bufA[1U] = 0b10000000 | address8; /* set instruction and address  */
    tx_bufA[2U] = 0x88U;                    /* set dummy data for receive   */
    tx_bufA[3U] = 0x77U;                    /* set dummy data for receive   */

    tx_numA = 4U;                           /* send data number             */

    P0_bit.no5 = 1U;                        /* set CS signal ON             */
    S_COMUNICATION();                       /* start communication          */
    P0_bit.no5 = 0U;                        /* set CS signal OFF            */
    readdata = (uint16_t)rx_bufA[2U] << 8U;
    readdata |= rx_bufA[3U];
    return (readdata);                      /* set read data from EEPROM    */
}

/***********************************************************************************************************************
* Function Name: S_MICRO_WRITE
* Description  : This function writes one address from EEPROM
* Arguments    : address
* Return Value : None(read data in rx_buf[2]&rx_buf[3])
***********************************************************************************************************************/
void S_MICRO_WRITE(uint8_t address8, uint16_t write_data)
{
    tx_bufA[0] = 0b00000001;                /* set start bit for EEPROM     */
    tx_bufA[1] = 0b01000000 | address8;     /* set instruction and address  */
    tx_bufA[2] = (uint8_t)(write_data >> 8U);/* set high data to write        */
    tx_bufA[3] = (uint8_t)write_data & 0xFF;/* set low data to write       */

    tx_numA = 4U;                           /* send data number             */

    P0_bit.no5 = 1U;                        /* set CS signal ON             */
    S_COMUNICATION();                       /* start communication          */
    P0_bit.no5 = 0U;                        /* set CS signal OFF            */
/*
 clear SO for verify operation
*/
    SOE0 &= ~_0008_SAU_CH3_OUTPUT_ENABLE;
    SO0 &= 0xFFF7U;                         /* clear SO11 output latch      */
    SOE0 |= _0008_SAU_CH3_OUTPUT_ENABLE;           /* enable CSI11 output */
}

/***********************************************************************************************************************
* Function Name: S_COMMUNICATION
* Description  : This function issue instruction of EEPROM
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void S_COMUNICATION(void)
{
    R_CSI11_Send_Receive(tx_bufA, tx_numA, rx_bufA);/* send instruction        */
 //   while (g_csi11_comflag)                         /* wait for transmit complete   */
 //   {
 //       NOP();
 //   }
}

/***********************************************************************************************************************
* Function Name: S_WAITEND
* Description  : This function wait for write/erase of EEPROM
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void S_WAITEND(void)
{

    S_WAITTSV();                            /* wait for 16clocks as tSV     */
    P0_bit.no5 = 1U;                        /* set CS signal ON             */
    S_WAITTSV();                            /* wait for 16clocks as tSV     */
    while (P0_bit.no5 == 0U)                /* wait for complete to write   */
    {
        NOP();
    }
    P0_bit.no5 = 0U;                        /* set CS signal OFF            */

}

/***********************************************************************************************************************
* Function Name: S_CHKEND
* Description  : This function wait for write/erase of EEPROM
* Arguments    : None
* Return Value : busy flag
***********************************************************************************************************************/
uint8_t S_CHKEND(void)
{
    uint8_t flag;
    S_WAITTSV();                            /* wait for 16clocks as tSV     */
    P0_bit.no5 = 1U;                        /* set CS signal ON             */
    flag = 0U;                              /* set ready status flag        */
    S_WAITTSV();                            /* wait for 16clocks as tSV     */
    if (P0_bit.no5 == 0U)                   /* check complete to write      */
    {
        flag = 0xFFU;                       /* set busy status flag         */
    }
    P0_bit.no5 = 0U;                        /* set CS signal OFF            */
    return (flag);
}

/***********************************************************************************************************************
* Function Name: S_WAITTSV
* Description  : wait for tSV
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void S_WAITTSV(void)
{
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
    NOP();
}
/***********************************************************************************************************************
* Function Name: init_eprom 
* Description  : This function erase all data of EEPROM
* Arguments    : None
* Return Value : Bool
***********************************************************************************************************************/
_Bool  init_eprom (void )
{
	int i;
	for(i = 0 ; i < 64 ; i++)
	{
		S_MICRO_EWEN();
		NOP();
		S_MICRO_WRITE(i , 0xFFFF);
		 while (S_CHKEND())
        	{                                   /* wait for complete function   */
            		NOP();
       		}
		S_MICRO_WRITE(i , 0xFFFF);
		 while (S_CHKEND())
        	{                                   /* wait for complete function   */
            		NOP();
       		}
		S_MICRO_WRITE(i , 0xFFFF);
		 while (S_CHKEND())
        	{                                   /* wait for complete function   */
            		NOP();
       		}
		NOP();
		NOP();
		NOP();
	}
	return 0;
}

/***********************************************************************************************************************
* Function Name: write_eeprom 
* Description  : This function writes one address from EEPROM
* Arguments    : address data
* Return Value : Bool
***********************************************************************************************************************/
_Bool  write_eeprom (uint8_t address1, uint16_t write_data1)
{
	S_MICRO_EWEN();
	NOP();
	S_MICRO_WRITE(address1 , write_data1);
	 while (S_CHKEND())
        {                                   /* wait for complete function   */
        	NOP();
       	}
	NOP();
	S_MICRO_EWEN();
	NOP();
	S_MICRO_WRITE(address1 , write_data1);
	 while (S_CHKEND())
        {                                   /* wait for complete function   */
        	NOP();
       	}
	NOP();
	S_MICRO_EWEN();
	NOP();
	S_MICRO_WRITE(address1 , write_data1);
	 while (S_CHKEND())
        {                                   /* wait for complete function   */
        	NOP();
       	}
	NOP();
	NOP();
	NOP();
	return 0;
}

/***********************************************************************************************************************
* Function Name: read_eeprom 
* Description  : This function reads one address from EEPROM
* Arguments    : address data
* Return Value : Bool
***********************************************************************************************************************/
_Bool  read_eeprom (uint8_t address1 , uint8_t count , WORD* rx_data )
{
	int i;
	for(i = 0 ; i < count ; i++)
	{
		*rx_data = S_MICRO_READ(address1);
		*rx_data++;
		NOP();
	}
	return 0;
}


/***********************************************************************************************************************
* Function Name: read_eeprom2 
* Description  : This function reads one address from EEPROM
* Arguments    : address data
* Return Value : Bool
***********************************************************************************************************************/
_Bool  read_eeprom2 (uint8_t address1 , uint8_t count , DWORD* rx_data )
{
	int i;
	for(i = 0 ; i < count ; i++)
	{
		*rx_data = S_MICRO_READ(address1);
		*rx_data++;
		address1++;
		NOP();
	}
	return 0;
}
