/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2018 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_intc_user.c
* Version      : CodeGenerator for RL78/G13 V2.05.03.01 [12 Nov 2018]
* Device(s)    : R5F100LL
* Tool-Chain   : CCRL
* Description  : This file implements device driver for INTC module.
* Creation Date: 2019/11/20
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_intc.h"
/* Start user code for include. Do not edit comment generated here */
#include "std.h"
#include <stdbool.h>
#include <string.h>
#include "stdlib.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
#pragma interrupt r_intc6_interrupt(vect=INTP6)
#pragma interrupt r_intc7_interrupt(vect=INTP7)
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */

extern Global _Bool elimi_on_flag;	/* ۊoontO */
extern Global	WORD cnt_pump_rpm;	/* |v]JE^ */
void dis_inter(void);

/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: r_intc6_interrupt
* Description  : This function is INTP6 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_intc6_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
	PIF6 = 0;	/* ݗvtONA PIF3 -> PIF6 P782 */

	if(elimi_on_flag){
		ELIMI_PORT = true; 
	}else{
		ELIMI_PORT = false; 
	}

	inter_zero_flag = true;
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_intc7_interrupt
* Description  : This function is INTP7 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_intc7_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
	PIF7 = false;	/* ݗvtONA  PIF0 -> PIF7 P782 */

	if(INT0_PORT){
		
		++cnt_pump_rpm;
	}
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/***********************************************************************************************************************
* Function Name: dis_inter
* Description  : S荞݋֎~.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void dis_inter(void)
{
	MK0L = 0xFF;
	MK0H = 0xFF;
	MK1L = 0xFF;
	MK1H = 0xFF;
	MK2L = 0xFF;
	MK2H = 0xFF;
}
/* End user code. Do not edit comment generated here */
