/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2018 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_timer_user.c
* Version      : CodeGenerator for RL78/G13 V2.05.03.01 [12 Nov 2018]
* Device(s)    : R5F100LL
* Tool-Chain   : CCRL
* Description  : This file implements device driver for TAU module.
* Creation Date: 2019/11/20
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_timer.h"
/* Start user code for include. Do not edit comment generated here */
#include "std.h"
#include <stdbool.h>
#include <string.h>
#include "stdlib.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
#pragma interrupt r_tau0_channel0_interrupt(vect=INTTM00)
#pragma interrupt r_tau0_channel1_interrupt(vect=INTTM01)
#pragma interrupt r_tau0_channel2_interrupt(vect=INTTM02)
#pragma interrupt r_tau0_channel3_interrupt(vect=INTTM03)
#pragma interrupt r_tau0_channel4_interrupt(vect=INTTM04)
#pragma interrupt r_tau0_channel5_interrupt(vect=INTTM05)
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
extern Global BYTE qut_counter;		/* 0.25bJE^ */
extern Global BYTE sec_counter;		/* 1bJE^ */
extern Global BYTE min_counter;		/* 1JE^ */
extern Global BYTE hour_counter;		/* 1ԃJE^ */
extern Global BYTE day_counter;		/* 1JE^ */
extern Global BYTE guard_counter;		/* K[h^C}[JE^[ */
extern Global BYTE guard_counter2;		/* K[h^C}[2JE^[ */
extern Global BYTE guard_counter3;		/* K[h^C}[3JE^[ */
extern Global BYTE guard_counter4;		/* K[h^C}[3JE^[ */
extern Global DWORD pump_on_sec;		/* |v^](b) */
extern Global WORD on_sec;				/* |v݃`FbN^](b) */
extern Global BYTE on_sec_watt;		/* d͈Jn(b) */
extern Global _Bool pump_write;				/* |v݃tO */
extern Global BYTE pump_off_sec;		/* |v~ԁ@1bJE^ */
extern Global BYTE pump_off_min;		/* |v~ԁ@1JE^ */
extern Global BYTE pump_off_hour;		/* |v~ԁ@1ԃJE^ */


/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: r_tau0_channel0_interrupt
* Description  : This function is INTTM00 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_tau0_channel0_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_tau0_channel1_interrupt
* Description  : This function is INTTM01 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_tau0_channel1_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */

	static WORD PulsBuff[SMP_CNT_PULS];
	WORD* buff;
	DWORD data = 0; 

	TMIF01 =false;	/* ݗvNA */
//	P1_bit.no5 = ~P1_bit.no5;
//	CNT_PULS = CR01;
	CNT_PULS = TDR03;

	/* ]ړ(4) */
	buff = PulsBuff;
	memmove(buff+1,buff,(SMP_CNT_PULS-1)*2);
	*buff = CNT_PULS;
	data = (DWORD)PulsBuff[0]+(DWORD)PulsBuff[1]+(DWORD)PulsBuff[2]+(DWORD)PulsBuff[3];
	data /= SMP_CNT_PULS;
	Ave_puls = data;
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_tau0_channel2_interrupt
* Description  : This function is INTTM02 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_tau0_channel2_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
//	WTIF=0;	/* ݗvNA */
	TMIF02=0;	/* ݗvNA */
//	P1_bit.no0 = ~P1_bit.no0;
	if (++qut_counter >= 4) {
		qut_counter=0;

		if (guard_counter2 > 0) {
			--guard_counter2;
		}

		if (guard_counter3 > 0) {
			--guard_counter3;
		}

		if (guard_counter4 > 0) {
			--guard_counter4;
		}

		if (++sec_counter >= 60) {
			sec_counter=0;
			if (guard_counter > 0) {
				--guard_counter;
			}
			if (++min_counter >= 60) {
				min_counter=0;
				if (++hour_counter >= 24) {
					hour_counter=0;
					++day_counter;
				}
			}
		}
	}
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_tau0_channel3_interrupt
* Description  : This function is INTTM03 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_tau0_channel3_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_tau0_channel4_interrupt
* Description  : This function is INTTM04 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_tau0_channel4_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
       	
//	TMIF04=0;	/* ݗvNA  WTIIF -> TMIF05 P781 */
//	inter1ms_rq=false;
//	inter1m_led();			/* led */

    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_tau0_channel5_interrupt
* Description  : This function is INTTM05 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
static void __near r_tau0_channel5_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
    	
	TMIF05=0;	/* ݗvNA  WTIIF -> TMIF05 P781 */
//	P1_bit.no7 = ~P1_bit.no7;
	inter1ms_rq=false;
	inter1m_led();			/* led */

    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
